SystemOrganization addCategory: #'CTM-Core'!
SystemOrganization addCategory: #'CTM-Example'!

!MethodReference methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 14:59'!
isReferenceToGeneratedMethod

	^ self compiledMethod isCTMGeneratedMethod! !

Object subclass: #CTMEventListener
	instanceVariableNames: 'methodManagement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

CTMEventListener class
	instanceVariableNames: 'instance'!

CTMEventListener class
	instanceVariableNames: 'instance'!

!CTMEventListener class methodsFor: 'as yet unclassified' stamp: 'mig 12/8/2010 20:35'!
instance

	^ instance ifNil: [ instance := self new ]! !

!CTMEventListener class methodsFor: 'as yet unclassified' stamp: 'mig 1/7/2011 10:37'!
reset

	instance ifNotNil: [instance unregister].
	instance := nil.
! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 21:37'!
event: anEvent

	(anEvent itemKind == #method) ifTrue: [ self methodEvent: anEvent ].! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 13:20'!
methodEvent: anEvent

	| pragmas method |
	method := self methodManagement prepareMethod: anEvent item from: anEvent oldItem.
	
	pragmas := method pragmas.
	pragmas do: [ :pragma |
		CTMThing allSubclassesDo: [:class | | instance |
			instance := class new.
			(instance matchMethodPragma: pragma) ifTrue: [instance handleMethodEvent: anEvent]]].
	

! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 11:53'!
methodManagement

	^ methodManagement ifNil: [ methodManagement := CTMMethodManagement new]! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/9/2010 20:12'!
register

	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/9/2010 20:13'!
unregister

	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

Object subclass: #CTMMethodManagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMMethodManagement methodsFor: 'generated-method-handling' stamp: 'SR 1/7/2011 13:20'!
addGeneratedMethodFor: aCompiledMethod with: aCodeString

	| class method generatedMethods |
	class := aCompiledMethod methodClass.
	method := self addMethodTo: class in: #generated with: aCodeString.
	method ifNil: [ ^ nil ].
	
	"Mark new method as generated method"
	method isCTMGeneratedMethod: true.
	
	"Add new method to generated methods list"
	generatedMethods := aCompiledMethod ctmGeneratedMethodsForThis.
	(generatedMethods contains: [:i | i = method selector]) ifFalse: [generatedMethods add: (method selector)].
	aCompiledMethod ctmGeneratedMethodsForThis: generatedMethods.! !

!CTMMethodManagement methodsFor: 'normal-method-handling' stamp: 'SR 1/7/2011 15:07'!
addMethodTo: aClass in: aCategorySymbol with: aCodeString

	| methodAndNode selector |
	methodAndNode := aClass compile: aCodeString classified: aCategorySymbol notifying: nil trailer: aClass defaultMethodTrailer ifFail: [^nil].
	selector := methodAndNode selector.
	
	(aClass methodDictionary includesKey: selector) ifTrue: [
		(aClass>>selector) isCTMGeneratedMethod ifTrue: [ ^ nil ].
	].

	aClass logMethodSource: aCodeString forMethodWithNode: methodAndNode inCategory: aCategorySymbol withStamp: (Utilities changeStamp) notifying: nil.
	aClass addAndClassifySelector: selector withMethod: methodAndNode method inProtocol: aCategorySymbol notifying: nil.
	^ methodAndNode method! !

!CTMMethodManagement methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 13:18'!
copyCTMPropertiesFrom: anOldCompiledMethod to: aCompiledMethod
	
	aCompiledMethod isCTMGeneratedMethod: (anOldCompiledMethod isCTMGeneratedMethod).
	aCompiledMethod ctmGeneratedMethodsForThis: (anOldCompiledMethod ctmGeneratedMethodsForThis).! !

!CTMMethodManagement methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 13:17'!
prepareMethod: aCompiledMethod from: anOldCompiledMethod

	"Copy our properties from the old method to the new one"
	anOldCompiledMethod ifNotNil: [self copyCTMPropertiesFrom: anOldCompiledMethod to: aCompiledMethod].
	
	"Cleanup generated methods"
	self removeAllGeneratedMethodsFor: aCompiledMethod.
	^ aCompiledMethod methodClass compiledMethodAt: (aCompiledMethod selector) ifAbsent: [ "The method is not in the method dict, so this was caused by an remove event" aCompiledMethod ]! !

!CTMMethodManagement methodsFor: 'generated-method-handling' stamp: 'SR 1/7/2011 13:16'!
removeAllGeneratedMethodsFor: aCompiledMethod

	| class |
	class := aCompiledMethod methodClass.
	
	aCompiledMethod ctmGeneratedMethodsForThis do: [ :methodSelector |
		(class methodDictionary includesKey: methodSelector) ifTrue: [
			self removeMethod: (class>>methodSelector)]].

	aCompiledMethod ctmGeneratedMethodsForThis: (OrderedCollection new).! !

!CTMMethodManagement methodsFor: 'normal-method-handling' stamp: 'SR 1/7/2011 11:06'!
removeMethod: aCompiledMethod

	| class selector |
	class := aCompiledMethod methodClass.
	selector := aCompiledMethod selector.
	
	self removeAllGeneratedMethodsFor: aCompiledMethod.
	class removeSelector: selector.! !

Object subclass: #CTMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Example'!

!CTMTest methodsFor: 'as yet unclassified' stamp: 'mig 1/7/2011 15:28'!
micha: anArray micha2: aSecondArray micha3: aThirdArray

	<optional: #micha: default: 2 optional: #micha3: default: 3>
	
	anArray inspect.! !

!CTMTest methodsFor: 'as yet unclassified' stamp: 'mig 1/7/2011 16:26'!
shortcut: anArray

	<shortcuts: #short count: 3>
	anArray inspect.! !

Object subclass: #CTMThing
	instanceVariableNames: 'methodManagement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

CTMThing subclass: #CTMOptionalParameterThing
	instanceVariableNames: 'config'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMOptionalParameterThing methodsFor: 'pragma-matching' stamp: 'SR 1/7/2011 13:37'!
config

	^ config ifNil: [ config := Dictionary new].! !

!CTMOptionalParameterThing methodsFor: 'pragma-matching' stamp: 'mig 1/7/2011 14:38'!
matchMethodPragma: aPragma

	(aPragma keyword asString matchesRegex: '^(optional\:default\:)*$') ifTrue: [
		aPragma arguments pairsDo: [:key :value |
			self config at: key put: value].
		^ true].
	
	^ super matchMethodPragma: aPragma! !

!CTMOptionalParameterThing methodsFor: 'method-events' stamp: 'mig 1/7/2011 15:07'!
methodAdded: aMethod in: aClass

	self config keys allCombinationsDo: [:each | | signature difference signatureParts callParts code call |
		difference := aMethod selectorParts difference: each.
		signatureParts := difference collectWithIndex: [ :each2 :index | '{1} t{2}' format: {each2 asString. index asString.}].
		signature := signatureParts inject: '' into: [:subTotal :next | '{1} {2}' format: {subTotal. next.}].
		
		callParts := aMethod selectorParts collect: [:each2 | (self config includesKey: each2)
				ifTrue: ['<1s> <2p>' expandMacrosWith: each2 with: (self config at: each2)]
				ifFalse: ['<1s> t<2p>' expandMacrosWith: each2 with: (difference indexOf: each2)]].
		call := callParts inject: '' into: [:subTotal :next | '<1s> <2s>' expandMacrosWith: subTotal with: next].
		
		code := '<1s><n><n><t>^ self <2s>' expandMacrosWith: signature with: call.
		self methodManagement addGeneratedMethodFor: aMethod with: code.
	].! !

CTMThing subclass: #CTMShortcutsThing
	instanceVariableNames: 'shortcutName shortcutMaxCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMShortcutsThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 21:50'!
matchMethodPragma: aPragma

	(aPragma keyword = #shortcuts:count:) ifTrue: [
		shortcutName := aPragma argumentAt: 1.
		shortcutMaxCount := aPragma argumentAt: 2.
		^ true].
	
	^ super matchMethodPragma: aPragma! !

!CTMShortcutsThing methodsFor: 'method-events' stamp: 'mig 1/7/2011 16:26'!
methodAdded: aMethod in: aClass
	
	| methodName collectionCreation parameterName |
	methodName := ''.
	collectionCreation := ''.
	parameterName := aMethod ast arguments last token value, 'Element'.
	
	1 to: shortcutMaxCount do: [ :i | | code |
		methodName := '<1s> <2s>: <3s><4p> ' expandMacrosWithArguments: {methodName. shortcutName. parameterName. i}.
		collectionCreation := '<1s><2s><3p>. ' expandMacrosWithArguments: {collectionCreation. parameterName. i}.
		
		code := '<1s><n><t>^ self <2s> (OrderedCollection newFrom: {<3s>})' expandMacrosWith: methodName with: aMethod selector with: collectionCreation.
		self methodManagement addGeneratedMethodFor: aMethod with: code.
	].! !

!CTMThing class methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 21:59'!
convertModifiedToAddedRemoved

	^ true! !

!CTMThing methodsFor: 'internal' stamp: 'SR 1/6/2011 21:57'!
handleMethodEvent: anEvent

	| class method |
	method := anEvent item.
	class := anEvent environmentAt: #class.

	anEvent isAdded ifTrue: [ ^ self methodAdded: method in: class ].
	anEvent isModified ifTrue: [ ^ self methodModified: method in: class from: (anEvent oldItem) ].
	anEvent isRemoved ifTrue: [ ^ self methodRemoved: method in: class ].! !

!CTMThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 22:03'!
matchClassPragma: aPragma

	^ false! !

!CTMThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 21:25'!
matchMethodPragma: aPragma

	^ false! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 21:32'!
methodAdded: aMethod in: aClass
! !

!CTMThing methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 22:03'!
methodManagement

	^ methodManagement ifNil: [ methodManagement := CTMMethodManagement new].! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 22:00'!
methodModified: aMethod in: aClass from: anOldMethod

	self class convertModifiedToAddedRemoved ifTrue: [
		self methodRemoved: anOldMethod in: aClass.
		self methodAdded: aMethod in: aClass]! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 21:38'!
methodRemoved: aMethod in: aClass! !

!MCPackage methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 15:00'!
snapshot
	| packageInfo definitions categories |
	packageInfo := self packageInfo.
	definitions := OrderedCollection new.
	categories := packageInfo systemCategories.
	categories isEmpty ifFalse: [ definitions add: (MCOrganizationDefinition categories: categories) ].
	packageInfo methods do: [:ea | ea isReferenceToGeneratedMethod ifFalse: [ definitions add: ea asMethodDefinition]] displayingProgress: 'Snapshotting methods...'.
	(packageInfo respondsTo: #overriddenMethods) ifTrue:
		[packageInfo overriddenMethods
			do: [:ea | definitions add:
					(packageInfo changeRecordForOverriddenMethod: ea) asMethodDefinition]
			displayingProgress: 'Searching for overrides...'].
	packageInfo classes do: [:ea | definitions addAll: ea classDefinitions] displayingProgress: 'Snapshotting classes...'.
	(packageInfo respondsTo: #hasPreamble) ifTrue: [
		packageInfo hasPreamble ifTrue: [definitions add: (MCPreambleDefinition from: packageInfo)].
		packageInfo hasPostscript ifTrue: [definitions add: (MCPostscriptDefinition from: packageInfo)].
		packageInfo hasPreambleOfRemoval ifTrue: [definitions add: (MCRemovalPreambleDefinition from: packageInfo)].
		packageInfo hasPostscriptOfRemoval ifTrue: [definitions add: (MCRemovalPostscriptDefinition from: packageInfo)]]. 
	^ MCSnapshot fromDefinitions: definitions
! !

!OBMorphicIcons methodsFor: '*CTM-Core' stamp: 'mig 1/7/2011 16:17'!
generated
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #(0 0 0 0 0 0 0 0 0 0 3132733881 3103784960 186 3237148907 3233349632 185 4075151077 3854106624 185 4076863487 3736666112 185 3957251806 3736666112 186 3236224698 3115909120 0 3132733881 3103784960 0 0 0 0 0 0)
	offset: 0@0)
	colors: {Color transparent . Color black . Color white . Color gray . Color red . Color green . Color blue . Color cyan . Color yellow . Color magenta . Color veryVeryDarkGray . Color veryDarkGray . Color darkGray . Color lightGray . Color veryLightGray . Color veryVeryLightGray . (Color r: 0.031 g: 0.031 b: 0.031) . (Color r: 0.063 g: 0.063 b: 0.063) . (Color r: 0.094 g: 0.094 b: 0.094) . (Color r: 0.156 g: 0.156 b: 0.156) . (Color r: 0.188 g: 0.188 b: 0.188) . (Color r: 0.219 g: 0.219 b: 0.219) . (Color r: 0.282 g: 0.282 b: 0.282) . (Color r: 0.313 g: 0.313 b: 0.313) . (Color r: 0.344 g: 0.344 b: 0.344) . (Color r: 0.407 g: 0.407 b: 0.407) . (Color r: 0.438 g: 0.438 b: 0.438) . (Color r: 0.469 g: 0.469 b: 0.469) . (Color r: 0.531 g: 0.531 b: 0.531) . (Color r: 0.562 g: 0.562 b: 0.562) . (Color r: 0.593 g: 0.593 b: 0.593) . (Color r: 0.656 g: 0.656 b: 0.656) . (Color r: 0.687 g: 0.687 b: 0.687) . (Color r: 0.718 g: 0.718 b: 0.718) . (Color r: 0.781 g: 0.781 b: 0.781) . (Color r: 0.812 g: 0.812 b: 0.812) . (Color r: 0.844 g: 0.844 b: 0.844) . (Color r: 0.906 g: 0.906 b: 0.906) . (Color r: 0.937 g: 0.937 b: 0.937) . (Color r: 0.969 g: 0.969 b: 0.969) . Color black . (Color r: 0.0 g: 0.199 b: 0.0) . (Color r: 0.0 g: 0.4 b: 0.0) . (Color r: 0.0 g: 0.599 b: 0.0) . (Color r: 0.0 g: 0.8 b: 0.0) . Color green . (Color r: 0.0 g: 0.0 b: 0.199) . (Color r: 0.0 g: 0.199 b: 0.199) . (Color r: 0.0 g: 0.4 b: 0.199) . (Color r: 0.0 g: 0.599 b: 0.199) . (Color r: 0.0 g: 0.8 b: 0.199) . (Color r: 0.0 g: 1.0 b: 0.199) . (Color r: 0.0 g: 0.0 b: 0.4) . (Color r: 0.0 g: 0.199 b: 0.4) . (Color r: 0.0 g: 0.4 b: 0.4) . (Color r: 0.0 g: 0.599 b: 0.4) . (Color r: 0.0 g: 0.8 b: 0.4) . (Color r: 0.0 g: 1.0 b: 0.4) . (Color r: 0.0 g: 0.0 b: 0.599) . (Color r: 0.0 g: 0.199 b: 0.599) . (Color r: 0.0 g: 0.4 b: 0.599) . (Color r: 0.0 g: 0.599 b: 0.599) . (Color r: 0.0 g: 0.8 b: 0.599) . (Color r: 0.0 g: 1.0 b: 0.599) . (Color r: 0.0 g: 0.0 b: 0.8) . (Color r: 0.0 g: 0.199 b: 0.8) . (Color r: 0.0 g: 0.4 b: 0.8) . (Color r: 0.0 g: 0.599 b: 0.8) . (Color r: 0.0 g: 0.8 b: 0.8) . (Color r: 0.0 g: 1.0 b: 0.8) . Color blue . (Color r: 0.0 g: 0.199 b: 1.0) . (Color r: 0.0 g: 0.4 b: 1.0) . (Color r: 0.0 g: 0.599 b: 1.0) . (Color r: 0.0 g: 0.8 b: 1.0) . Color cyan . (Color r: 0.199 g: 0.0 b: 0.0) . (Color r: 0.199 g: 0.199 b: 0.0) . (Color r: 0.199 g: 0.4 b: 0.0) . (Color r: 0.199 g: 0.599 b: 0.0) . (Color r: 0.199 g: 0.8 b: 0.0) . (Color r: 0.199 g: 1.0 b: 0.0) . (Color r: 0.199 g: 0.0 b: 0.199) . (Color r: 0.199 g: 0.199 b: 0.199) . (Color r: 0.199 g: 0.4 b: 0.199) . (Color r: 0.199 g: 0.599 b: 0.199) . (Color r: 0.199 g: 0.8 b: 0.199) . (Color r: 0.199 g: 1.0 b: 0.199) . (Color r: 0.199 g: 0.0 b: 0.4) . (Color r: 0.199 g: 0.199 b: 0.4) . (Color r: 0.199 g: 0.4 b: 0.4) . (Color r: 0.199 g: 0.599 b: 0.4) . (Color r: 0.199 g: 0.8 b: 0.4) . (Color r: 0.199 g: 1.0 b: 0.4) . (Color r: 0.199 g: 0.0 b: 0.599) . (Color r: 0.199 g: 0.199 b: 0.599) . (Color r: 0.199 g: 0.4 b: 0.599) . (Color r: 0.199 g: 0.599 b: 0.599) . (Color r: 0.199 g: 0.8 b: 0.599) . (Color r: 0.199 g: 1.0 b: 0.599) . (Color r: 0.199 g: 0.0 b: 0.8) . (Color r: 0.199 g: 0.199 b: 0.8) . (Color r: 0.199 g: 0.4 b: 0.8) . (Color r: 0.199 g: 0.599 b: 0.8) . (Color r: 0.199 g: 0.8 b: 0.8) . (Color r: 0.199 g: 1.0 b: 0.8) . (Color r: 0.199 g: 0.0 b: 1.0) . (Color r: 0.199 g: 0.199 b: 1.0) . (Color r: 0.199 g: 0.4 b: 1.0) . (Color r: 0.199 g: 0.599 b: 1.0) . (Color r: 0.199 g: 0.8 b: 1.0) . (Color r: 0.199 g: 1.0 b: 1.0) . (Color r: 0.4 g: 0.0 b: 0.0) . (Color r: 0.4 g: 0.199 b: 0.0) . (Color r: 0.4 g: 0.4 b: 0.0) . (Color r: 0.4 g: 0.599 b: 0.0) . (Color r: 0.4 g: 0.8 b: 0.0) . (Color r: 0.4 g: 1.0 b: 0.0) . (Color r: 0.4 g: 0.0 b: 0.199) . (Color r: 0.4 g: 0.199 b: 0.199) . (Color r: 0.4 g: 0.4 b: 0.199) . (Color r: 0.4 g: 0.599 b: 0.199) . (Color r: 0.4 g: 0.8 b: 0.199) . (Color r: 0.4 g: 1.0 b: 0.199) . (Color r: 0.4 g: 0.0 b: 0.4) . (Color r: 0.4 g: 0.199 b: 0.4) . (Color r: 0.4 g: 0.4 b: 0.4) . (Color r: 0.4 g: 0.599 b: 0.4) . (Color r: 0.4 g: 0.8 b: 0.4) . (Color r: 0.4 g: 1.0 b: 0.4) . (Color r: 0.4 g: 0.0 b: 0.599) . (Color r: 0.4 g: 0.199 b: 0.599) . (Color r: 0.4 g: 0.4 b: 0.599) . (Color r: 0.4 g: 0.599 b: 0.599) . (Color r: 0.4 g: 0.8 b: 0.599) . (Color r: 0.4 g: 1.0 b: 0.599) . (Color r: 0.4 g: 0.0 b: 0.8) . (Color r: 0.4 g: 0.199 b: 0.8) . (Color r: 0.4 g: 0.4 b: 0.8) . (Color r: 0.4 g: 0.599 b: 0.8) . (Color r: 0.4 g: 0.8 b: 0.8) . (Color r: 0.4 g: 1.0 b: 0.8) . (Color r: 0.4 g: 0.0 b: 1.0) . (Color r: 0.4 g: 0.199 b: 1.0) . (Color r: 0.4 g: 0.4 b: 1.0) . (Color r: 0.4 g: 0.599 b: 1.0) . (Color r: 0.4 g: 0.8 b: 1.0) . Color lightCyan . (Color r: 0.599 g: 0.0 b: 0.0) . (Color r: 0.599 g: 0.199 b: 0.0) . (Color r: 0.599 g: 0.4 b: 0.0) . (Color r: 0.599 g: 0.599 b: 0.0) . (Color r: 0.599 g: 0.8 b: 0.0) . (Color r: 0.599 g: 1.0 b: 0.0) . (Color r: 0.599 g: 0.0 b: 0.199) . (Color r: 0.599 g: 0.199 b: 0.199) . (Color r: 0.599 g: 0.4 b: 0.199) . (Color r: 0.599 g: 0.599 b: 0.199) . (Color r: 0.599 g: 0.8 b: 0.199) . (Color r: 0.599 g: 1.0 b: 0.199) . (Color r: 0.599 g: 0.0 b: 0.4) . (Color r: 0.599 g: 0.199 b: 0.4) . (Color r: 0.599 g: 0.4 b: 0.4) . (Color r: 0.599 g: 0.599 b: 0.4) . (Color r: 0.599 g: 0.8 b: 0.4) . (Color r: 0.599 g: 1.0 b: 0.4) . (Color r: 0.599 g: 0.0 b: 0.599) . (Color r: 0.599 g: 0.199 b: 0.599) . (Color r: 0.599 g: 0.4 b: 0.599) . (Color r: 0.599 g: 0.599 b: 0.599) . (Color r: 0.599 g: 0.8 b: 0.599) . (Color r: 0.599 g: 1.0 b: 0.599) . (Color r: 0.599 g: 0.0 b: 0.8) . (Color r: 0.599 g: 0.199 b: 0.8) . (Color r: 0.599 g: 0.4 b: 0.8) . (Color r: 0.599 g: 0.599 b: 0.8) . (Color r: 0.599 g: 0.8 b: 0.8) . (Color r: 0.599 g: 1.0 b: 0.8) . (Color r: 0.599 g: 0.0 b: 1.0) . (Color r: 0.599 g: 0.199 b: 1.0) . (Color r: 0.599 g: 0.4 b: 1.0) . (Color r: 0.599 g: 0.599 b: 1.0) . (Color r: 0.599 g: 0.8 b: 1.0) . (Color r: 0.599 g: 1.0 b: 1.0) . (Color r: 0.8 g: 0.0 b: 0.0) . (Color r: 0.8 g: 0.199 b: 0.0) . (Color r: 0.8 g: 0.4 b: 0.0) . (Color r: 0.8 g: 0.599 b: 0.0) . (Color r: 0.8 g: 0.8 b: 0.0) . (Color r: 0.8 g: 1.0 b: 0.0) . (Color r: 0.8 g: 0.0 b: 0.199) . (Color r: 0.8 g: 0.199 b: 0.199) . (Color r: 0.8 g: 0.4 b: 0.199) . (Color r: 0.8 g: 0.599 b: 0.199) . (Color r: 0.8 g: 0.8 b: 0.199) . (Color r: 0.8 g: 1.0 b: 0.199) . (Color r: 0.8 g: 0.0 b: 0.4) . (Color r: 0.8 g: 0.199 b: 0.4) . (Color r: 0.8 g: 0.4 b: 0.4) . (Color r: 0.8 g: 0.599 b: 0.4) . (Color r: 0.8 g: 0.8 b: 0.4) . (Color r: 0.8 g: 1.0 b: 0.4) . (Color r: 0.8 g: 0.0 b: 0.599) . (Color r: 0.8 g: 0.199 b: 0.599) . (Color r: 0.8 g: 0.4 b: 0.599) . (Color r: 0.8 g: 0.599 b: 0.599) . (Color r: 0.8 g: 0.8 b: 0.599) . (Color r: 0.8 g: 1.0 b: 0.599) . (Color r: 0.8 g: 0.0 b: 0.8) . (Color r: 0.8 g: 0.199 b: 0.8) . (Color r: 0.8 g: 0.4 b: 0.8) . (Color r: 0.8 g: 0.599 b: 0.8) . (Color r: 0.8 g: 0.8 b: 0.8) . (Color r: 0.8 g: 1.0 b: 0.8) . (Color r: 0.8 g: 0.0 b: 1.0) . (Color r: 0.8 g: 0.199 b: 1.0) . (Color r: 0.8 g: 0.4 b: 1.0) . (Color r: 0.8 g: 0.599 b: 1.0) . (Color r: 0.8 g: 0.8 b: 1.0) . Color lightBlue . Color red . (Color r: 1.0 g: 0.199 b: 0.0) . (Color r: 1.0 g: 0.4 b: 0.0) . (Color r: 1.0 g: 0.599 b: 0.0) . (Color r: 1.0 g: 0.8 b: 0.0) . Color yellow . (Color r: 1.0 g: 0.0 b: 0.199) . (Color r: 1.0 g: 0.199 b: 0.199) . (Color r: 1.0 g: 0.4 b: 0.199) . (Color r: 1.0 g: 0.599 b: 0.199) . (Color r: 1.0 g: 0.8 b: 0.199) . (Color r: 1.0 g: 1.0 b: 0.199) . (Color r: 1.0 g: 0.0 b: 0.4) . (Color r: 1.0 g: 0.199 b: 0.4) . (Color r: 1.0 g: 0.4 b: 0.4) . (Color r: 1.0 g: 0.599 b: 0.4) . Color lightOrange . (Color r: 1.0 g: 1.0 b: 0.4) . (Color r: 1.0 g: 0.0 b: 0.599) . (Color r: 1.0 g: 0.199 b: 0.599) . (Color r: 1.0 g: 0.4 b: 0.599) . (Color r: 1.0 g: 0.599 b: 0.599) . (Color r: 1.0 g: 0.8 b: 0.599) . (Color r: 1.0 g: 1.0 b: 0.599) . (Color r: 1.0 g: 0.0 b: 0.8) . (Color r: 1.0 g: 0.199 b: 0.8) . (Color r: 1.0 g: 0.4 b: 0.8) . (Color r: 1.0 g: 0.599 b: 0.8) . Color lightRed . Color lightYellow . Color magenta . (Color r: 1.0 g: 0.199 b: 1.0) . (Color r: 1.0 g: 0.4 b: 1.0) . (Color r: 1.0 g: 0.599 b: 1.0) . Color lightMagenta . Color white})! !

!ClassDescription methodsFor: '*CTM-Core-override' stamp: 'mig 1/7/2011 16:23'!
browserIcon: aClassDescription selector: aSelector
	"Answer an icon to be shown for the selector aSymbol in aClassDescription."

	aClassDescription methodDictionary at: aSelector ifPresent: [ :method |
		method literalsDo: [ :literal |
			(literal == #halt or: [ literal == #halt: or: [ literal == #haltIfNil or: [ literal == #haltIf: or: [ literal == #haltOnce or: [ literal == #haltOnce: or: [ literal == #haltOnCount: or: [ literal == #halt:onCount: ] ] ] ] ] ] ])
				ifTrue: [ ^ #breakpoint ].
			(literal == #flag: or: [ literal == #needsWork or: [ literal == #notYetImplemented ] ])
				ifTrue: [ ^ #flag ] ] ].
	(aClassDescription methodDictionary at: aSelector) isCTMGeneratedMethod ifTrue: [^ #generated].
	^ (aClassDescription isOverride: aSelector)
		ifTrue: [
			(aClassDescription isOverridden: aSelector)
				ifTrue: [ #arrowUpAndDown ]
				ifFalse: [ #arrowUp ] ]
		ifFalse: [
			(aClassDescription isOverridden: aSelector)
				ifTrue: [ #arrowDown ]
				ifFalse: [ #blank ] ]! !

!SequenceableCollection methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:49'!
allCombinationsDo: aBlock

	1 to: self size do: [:i | self combinations: i atATimeDo: aBlock]! !

!AbstractEvent methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:19'!
oldItem

	^ nil! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 11:00'!
ctmGeneratedMethodsForThis

	^ self propertyValueAt: #cmtGenerated ifAbsent: [OrderedCollection new].! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 11:00'!
ctmGeneratedMethodsForThis: aCollection

	^ self propertyValueAt: #cmtGenerated put: aCollection.! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:05'!
isCTMGeneratedMethod

	^ self propertyValueAt: #ctmGenerated ifAbsent: [false]! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:05'!
isCTMGeneratedMethod: aBoolean

	^ self propertyValueAt: #ctmGenerated put: aBoolean! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:56'!
selectorParts

	^ (self selector asString subStrings: ':') collect: [:each | (each,':') asSymbol]! !
